/*****************************************************************************
	
	powerest.cpp --  .   powerest.hpp.

	     Arageli.

	Copyright (C) Nikolai Yu. Zolotykh, 1999--2006
	Copyright (C) Sergey S. Lyalin, 2005
	University of Nizhni Novgorod, Russia

*****************************************************************************/

#include "config.hpp"

#if !defined(ARAGELI_INCLUDE_CPP_WITH_EXPORT_TEMPLATE) || \
	defined(ARAGELI_INCLUDE_CPP_WITH_EXPORT_TEMPLATE_POWEREST)

#include "powerest.hpp"


namespace Arageli
{


template <typename T, typename I, typename T_factory>
T power (T a, I n, const T_factory& tfctr)
{
	ARAGELI_ASSERT_0(!is_null(a) || is_positive(n));
	
	T res = tfctr.unit(a);
	while(!is_null(n))
	{
		if(is_odd(n))res = res * a;
		a *= a;
		n >>= 1;
	}
	
	return res;
}


} // namespace Arageli

#endif

