// Author : Aleksandrov Vladimir
// Tester : Sidnev Alexey 
// Creation date : 20.01.2006
// Modification date: 30.01.2006
// Testing date: 12.02.2006
// Description : * /

//1)   0
//2)   T=int.   2-  int' 
//big_int z=x*y;
// 2-   
//  .   z   .

#include "../ts_stdafx.hpp"
#include "rand.hpp"

#include <time.h>
#include <strstream>

using namespace Arageli;


template <class T>
bool big_int_multiply_divide (const T A,const T B)
{
	try
	{
		big_int a=A, b=B, d=a*b;
	
		T x=A, y=B;
		big_int z=x*y;

		if (z!=d)
		{
			tout<<"function multiply_divide failed on 1 check with A="<<A<<", B="<<B<<'\n';
			return true;
		}

		if ((a!=(a/b)*b+a%b)||(b!=(b/a)*a+b%a)) 
		{
			tout<<"function multiply_divide failed on 2 check with A="<<A<<", B="<<B<<'\n';
			return true;
		}
		return false;
	
		if ((a!=d/b+d%b)||(b!=d/a+d%a)) 
		{
			tout<<"function multiply_divide failed on 3 check with A="<<A<<", B="<<B<<'\n';
			return true;
		}
		return false;
	}
	catch(Arageli::exception& e)
	{
		tout << "EXCEPTION: ";
		e.output(tout); tout << '\n';
		return true;
	}
}


bool big_int_multiply_divide_test(int param, int count)
{
	bool fail=false;
	RNG gen(param,1<<16);

		//Message 1 fail |= big_int_multiply_divide(0,0);
	
		char x=3;
		char y=4;
		fail |= big_int_multiply_divide((signed char) (x),(signed char) (y));
		fail |= big_int_multiply_divide((unsigned char) (x),(unsigned char) (y));
		fail |= big_int_multiply_divide(x,y);

		if(fail) 
		{
			tout<<"Function big_int_multiply_divide_test failed on first step.\n";
			return fail;
		}

	
		for (int k=0; k<count; k++)
		{
			int a=gen.Rand()+1;
			int b=gen.Rand()+1;
			fail |= big_int_multiply_divide(a,b);
			fail |= big_int_multiply_divide(double (a),double (b));
			fail |= big_int_multiply_divide(float (a),float (b));
			fail |= big_int_multiply_divide(long (a),long (b));
			fail |= big_int_multiply_divide((long double) (a),(long double) (b));
			fail |= big_int_multiply_divide((signed short) (a),(signed short) (b));
			fail |= big_int_multiply_divide((unsigned short) (a),(unsigned short) (b));
			fail |= big_int_multiply_divide((unsigned) int (a),(unsigned int) (b));
			fail |= big_int_multiply_divide((signed) int (a),(signed int) (b));

			if(fail) 
			{
				tout<<"Function big_int_multiply_divide_test failed on "<<k+1<<" step.\n";
				return fail;
			}
		}
	
		bool a1=1;
		bool a2=1;
		fail |= big_int_multiply_divide(a1,a2);

		if(fail) 
		{
			tout<<"Function big_int_multiply_divide_test failed on last step.\n";
			return fail;
		}

	return false;
}

TEST(big_int,multiply_divide,"Test")
{ 
	bool fail=big_int_multiply_divide_test(100,1000);

	if(fail) return resFAIL;
	return resOK;

}
