// Author : Sidnev Alexey
// Tester :
// Creation date : 20.01.2006
// Modification date: 01.02.2006
// Testing date: 
// Description : Test of is_integer(). 
//		Be used: t_rational_is_integer.

#include "../ts_stdafx.hpp"

#include "rand.hpp"
#include "t_universal.hpp"
#include "t_rational.hpp"

using namespace Arageli;

bool rational_is_integer_test(int param, int count)
{
	bool fail=false;
	RNG gen(param);

	for(int k=0;k<count;k++)
	{
		int per1=gen.Rand(), per2=gen.Rand();
		big_int bper1=gen.Rand(), bper2=gen.Rand();

		while(!( per2=gen.Rand() ));
		while(!( bper2=gen.Rand() ));
	
		rational<int> ri(per1,per2);
		rational<big_int> rbi(bper1,bper2);

		fail |=t_rational_is_integer<int>(ri);
		fail |=t_rational_is_integer<big_int>(rbi);
	
		if(fail) 
		{
			tout<<"Function rational_is_integer_test failed on "<<k+1<<" step.\n";
			return fail;
		}
	}
	return false;
}

TEST(rational,is_integer,"Test is_integer() function.")
{ 
	bool fail=rational_is_integer_test(2396,1000);

	if(fail)
		return resFAIL;
	else
		return resOK;
}