// Author : Sidnev Alexey
// Tester :
// Creation date : 20.01.2006
// Modification date: 01.02.2006
// Testing date: 
// Description : Test of is_null(). 
//		Be used: t_rational_is_null.

#include "../ts_stdafx.hpp"

#include "t_universal.hpp"
#include "t_rational.hpp"
#include "rand.hpp"

using namespace Arageli;

bool rational_is_null_test(int param, int count)
{
	int k;
	try
	{
		bool fail=false;
		RNG gen(param);

		for(k=0;k<count;k++)
		{
			int per1=gen.Rand(), per2=gen.Rand();
			big_int bper1=gen.Rand(), bper2=gen.Rand();

			while(!( per2=gen.Rand() ));
			while(!( bper2=gen.Rand() ));

			rational<int> ri(per1,per2);
			rational<big_int> rbi(bper1,bper2);

			fail |=t_rational_is_null<int>(&ri);
			fail |=t_rational_is_null<big_int>(&rbi);
		
			if(fail) 
			{
				tout<<"Function rational_is_null_test failed on "<<k+1<<" step.\n";
				return fail;
			}
		}
		return false;
	}
	catch(...)
	{
		tout<<"Function rational_is_null_test failed on "<<k+1<<" step this EXCEPTION.\n";
		return true;
	}
}

TEST(rational,is_null,"Test is_null() function.")
{ 
	bool fail=rational_is_null_test(9234,1000);

	if(fail)
		return resFAIL;
	else
		return resOK;
}
